#include "global.h"

class GlobalPrivate
{
    public:
        inline GlobalPrivate()
        {
        }

        inline ~GlobalPrivate()
        {
        }

        ComponentData activeComponent;
        ComponentData mainComponent; // holds a refcount
};

K_GLOBAL_STATIC(GlobalPrivate,globalData);

#define PRIVATE_DATA GlobalPrivate *d = globalData

StandardDirs* Global::dirs()
{
    PRIVATE_DATA;
    return d->mainComponent.dirs();
}

SharedConfig::Ptr Global::config()
{
    PRIVATE_DATA;
    return d->mainComponent.config();
}

const ComponentData &Global::mainComponent()
{
    PRIVATE_DATA;
    return d->mainComponent;
}

bool Global::hasMainComponent()
{
    PRIVATE_DATA;

    return d->mainComponent.isValid();
}

ComponentData Global::activeComponent()
{
    PRIVATE_DATA;

    return d->activeComponent;
}

void Global::setActiveComponent(const ComponentData &c)
{
    PRIVATE_DATA;
    d->activeComponent = c;
}

void Global::newComponentData(const ComponentData &c)
{
    PRIVATE_DATA;
    if (d->mainComponent.isValid())
    {
        return;
    }
    d->mainComponent = c;
    Global::setActiveComponent(c);
}

